<?php
/**
 * @copyright	Copyright (C) 2017 Ing. Pavel Stary, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * version 3.8.0.1
 */

defined('JPATH_BASE') or die;

/**
 * Supports a modal article picker.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_content
 * @since		1.6
 */
class JFormFieldModal_Cats extends JFormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'Modal_Cats';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput()
	{  
    // set uncategorized for new articles
    $app = JFactory::getApplication();
    if($app->input->get('id') > 0 && !$this->value){
      $db	= JFactory::getDBO();
      $db->setQuery(
  			'SELECT id,title' .
  			' FROM #__categories' .
  			' WHERE extension = "com_content"'.
        ' ORDER BY id ASC'
  		,0,1);
      $res = $db->loadObject();
      $this->value = $res->id;      
    }      
    
    //$params		= JComponentHelper::getParams('com_multicats');
    
    $html = self::loadInputTypeChosen();
        
    return $html;
  }

  /**
   * Chosen Layout
   */
  protected function loadInputTypeChosen()
	{           
    $language = JFactory::getLanguage();
    $extension = 'com_content';
    $language_tag = $language->getTag(); // loads the current language-tag
    $language->load('com_multicats', JPATH_SITE, $language_tag, true);    

    $selected = explode(',',$this->value);    
    //is new
    $app = JFactory::getApplication();
    
    if(isset($this->value) && $this->value == '') {
      if(!$app->input->get('id') > 0){          
        $params		= JComponentHelper::getParams('com_multicats');
  	    $selected	= $params->get('catid','');  
      }
    }

    $options = self::getOptions();

    $script = '                    
    			function cwcategoryHasChanged(element) {

            var cat = jQuery(element);
    				//if (cat.val() == "14")return; //TODO loop selected cats
    				if (cat.val() != "0")return; //S63 added to prevent reloading and mobile selection
    				Joomla.loadingLayer("show");
    				jQuery("input[name=task]").val("article.reload");
    				element.form.submit();
    			}
          function changeIt() {
                        
                        var selectedIds = jQuery("#form_catids").val();
                        var results = [];
                        jQuery( "#form_catids_chzn .chzn-choices li.search-choice" ).each(function( index ) {                                                        
                          var id = jQuery("#form_catids option").eq(jQuery( this ).children("a").attr("data-option-array-index")).val();
                          if(jQuery.inArray(id, selectedIds) != -1) {
                            results.push( id );
                          } 
                        });
                        var results = results.join(",");
                        jQuery("#jformcatid").val(results);
                                    
          }  
                                 
    ';
    $doc = JFactory::getDocument();
    $doc->addScriptDeclaration($script);
    
		// The current user display field.
    $html[] = ' 

              <style>
                .chzn-container-multi .chzn-choices li.search-choice span { cursor: move; }
              </style>
              
              <script src="'.JUri::root().'components/com_multicats/helpers/jquery-ui-1.10.4.custom.min.js" type="text/javascript"></script>
              
              <script>
                jQuery(document).ready(function ($) {
                    
                    // reorder on load
                    var search = $( "#form_catids_chzn .chzn-choices li.search-field" );
                    $( "#form_catids_chzn .chzn-choices li.search-choice" ).each(function( index ) {
                        $(this).attr(\'id\',$("#form_catids option").eq($( this ).children("a").attr("data-option-array-index")).val());
                    });
                    
                    
                    var order = $("#jformcatid").val().split(\',\');
                    
                    var ul = $(\'#form_catids_chzn ul.chzn-choices\');
                    
                    $.each(order, function(index, sort) {
                        $(\'#\' + sort).appendTo(ul);
                    });
                    
                    ul.append(search);
                    
                    // On change                  
                    //$("#form_catids").on("change", function() { $("#jformcatid").val($("#form_catids").val());});
                    $("#form_catids").on("change", function() { 
                      
                      var selectedIds = $("#form_catids").val();
                      
                      var results = [];
                      $( "#form_catids_chzn .chzn-choices li.search-choice" ).each(function( index ) {                                                        
                        var id = $("#form_catids option").eq($( this ).children("a").attr("data-option-array-index")).val();
                        if($.inArray(id, selectedIds) != -1) {
                          results.push( id );
                        } 
                      });
                      var results = results.join(",");
                      $("#jformcatid").val(results);

                    });
                    
                    
                    // On sort
                    $("#form_catids_chzn ul.chzn-choices").sortable({
                        containment: \'parent\',
                        start: function() {                                                  
                        },
                        update: function() {
                          var results = [];
                          $( "#form_catids_chzn .chzn-choices li.search-choice" ).each(function( index ) {
                            //console.log( index + ": " + $( this ).text() + " selindex: " + $( this ).children("a").attr("data-option-array-index") + " ID: " + $("#form_catids option").eq($( this ).children("a").attr("data-option-array-index")).val() );                                                        
                            results.push( $("#form_catids option").eq($( this ).children("a").attr("data-option-array-index")).val() ); 
                          });  
                          var results = results.join(","); 
                          $("#jformcatid").val(results);
                          //$("#form_catids").on("change", function() { $("#jformcatid").val($("#form_catids").val());});
                          
                          var search = $( "#form_catids_chzn .chzn-choices li.search-field" );
                          var ul = $(\'#form_catids_chzn ul.chzn-choices\');
                          ul.find(".search-field").remove();

                          ul.append(search);
                        }
                    });
          
                });
             
          </script>                
          ';

    $app = JFactory::getApplication(); 
    $user = JFactory::getUser();
    $canCreate  = $user->authorise('core.create',     'com_content.category');
    if($app->isAdmin() && $canCreate){
      $html[] = ' 
          <script>              
                // NEW CATEGORY ON THE FLY
                jQuery(document).ready(function ($) {
                
                			var customTagPrefix = \'#new#\';
                
                			// Method to add tags pressing enter
                			$(\'#form_catids_chzn input\').keyup(function(event) {
                
                				// Tag is greater than the minimum required chars and enter pressed
                				if (this.value && this.value.length >= 3 && (event.which === 13 || event.which === 188)) {
                
                					// Search an highlighted result
                					var highlighted = $(\'#form_catids_chzn\').find(\'li.active-result.highlighted\').first();
                
                					// Add the highlighted option
                					if (event.which === 13 && highlighted.text() !== \'\')
                					{
                						// Extra check. If we have added a custom tag with this text remove it
                						var customOptionValue = customTagPrefix + highlighted.text();
                						$(\'#form_catids option\').filter(function () { return $(this).val() == customOptionValue; }).remove();
                
                						// Select the highlighted result
                						var tagOption = $(\'#form_catids option\').filter(function () { return $(this).html() == highlighted.text(); });
                						tagOption.attr(\'selected\', \'selected\');
                					}
                					// Add the custom tag option
                					else
                					{
                						var customTag = this.value;
                
                						// Extra check. Search if the custom tag already exists (typed faster than AJAX ready)
                						var tagOption = $(\'#form_catids option\').filter(function () { return $(this).html() == customTag; });
                						if (tagOption.text() !== \'\')
                						{
                							tagOption.attr(\'selected\', \'selected\');
                						}
                						else
                						{
                							var option = $(\'<option>\');
                							option.text(this.value).val(customTagPrefix + this.value);
                							option.attr(\'selected\',\'selected\');
                
                							// Append the option an repopulate the chosen field
                							$(\'#form_catids\').append(option);
                						}
                					}
                
                					this.value = \'\';
                					$(\'#form_catids\').trigger(\'liszt:updated\');
                					event.preventDefault();
                
                          //ON CHANGE - from line#100-110
                          //TODO better way then having same code twice
                            var selectedIds = $("#form_catids").val();
                            var results = [];
                            $( "#form_catids_chzn .chzn-choices li.search-choice" ).each(function( index ) {                                                        
                              var id = $("#form_catids option").eq($( this ).children("a").attr("data-option-array-index")).val();
                              if($.inArray(id, selectedIds) != -1) {
                                results.push( id );
                              } 
                            });
                            var results = results.join(",");
                            $("#jformcatid").val(results);
                          // END COPY CODE                        
                
                				}
                			});
                		});                
              </script>
             
          ';
    }
    
    if(isset($this->value) && $this->value != '') {
      $val = $this->value;
    } elseif(isset($selected) && !is_array($selected)){
      $val = $selected;
    } else {
      $val = '';
    }
    
    $html[] = '<input type="hidden" value="'. $val .'" name="jform[catid]" id="jformcatid" />';
          
		// The current user display field.
		$html[] = '<div class="fltlft">';
    //$html[] = JHTML::_('select.genericlist', $options, 'mcats[]', 'name="mcats[]" multiple="true" class="inputbox"', 'value', 'text', $selected);
    //$html[] = JHTML::_('select.genericlist', $options, ''.$this->name.'[]', 'name="'.$this->name.'" multiple="true" class="inputbox"', 'value', 'text', $selected);
    
    //3.8.1
    //get fields to find out if refresh callback is needed - otherwise calling it will cause bug
    $onchange = '';
    JLoader::register('FieldsHelper', JPATH_ADMINISTRATOR . '/components/com_fields/helpers/fields.php'); 
    $fields = FieldsHelper::getFields('com_content.article');
    if($fields){
      $onchange = 'changeIt();cwcategoryHasChanged(this);';
      $app = JFactory::getApplication();
      if( !$app->isAdmin() ) {
        $onchange = 'changeIt();cwcategoryHasChanged(this);';
      }
    } else {
      $onchange = 'cwcategoryHasChanged(this);';
    }
    
    if(isset($selected) && !is_array($selected)){      
      $selected = array($selected);
      //print_r($selected);
    }

    $html[] = '
              <select id="form_catids" name="form_catids[]" multiple="true" class="inputbox"  onchange="'.$onchange.'">
              ';                            
              foreach($options as $option){
                $disabled = '';
                $sel = '';
                if(isset($option->disable) && $option->disable != ''){
                  $disabled = "disabled";
                }
                if(is_array($selected) && in_array($option->value,$selected)) {
                  $sel = "selected";
                }
              	$html[] = '<option value="'.$option->value.'" '.$disabled.' '.$sel.'>'.$option->text.'</option>';
              }    
    $html[] = '
              </select>
    ';
    //$html[] = JHTML::_('select.genericlist', $options, 'form_catids[]', 'id="form_catids" multiple="true" class="inputbox" onchange="'.$onchange.'"', 'value', 'text', $selected);
    
    $html[] = '</div>';
        
    return implode("\n", $html);
  }  
  
  /**
   * Standard Layout
   * deprecated   
   */        
  protected function loadInputTypeStandard()
	{}


  /**
   * Method for getting category options  
  */
	protected function getOptions()
	{
		$options = array();
		$extension = 'com_content';
		$published = (string) $this->element['published'];

		// Load the category options for a given extension.
		if (!empty($extension))
		{
			// Filter over published state or not depending upon if it is present.
			if ($published)
			{
				$options = JHtml::_('category.options', $extension, array('filter.published' => explode(',', $published)));
			}
			else
			{
				$options = JHtml::_('category.options', $extension);
			}

			// Verify permissions.  If the action attribute is set, then we scan the options.
			if ((string) $this->element['action'])
			{

				// Get the current user object.
				$user = JFactory::getUser();

				foreach ($options as $i => $option)
				{
					/*
					 * To take save or create in a category you need to have create rights for that category
					 * unless the item is already in that category.
					 * Unset the option if the user isn't authorised for it. In this field assets are always categories.
					 */
					if ($user->authorise('core.create', $extension . '.category.' . $option->value) != true)
					{
						unset($options[$i]);
					}
				}

			}

			if (isset($this->element['show_root']))
			{
				array_unshift($options, JHtml::_('select.option', '0', JText::_('JGLOBAL_ROOT')));
			}
		}
		else
		{
			JLog::add(JText::_('JLIB_FORM_ERROR_FIELDS_CATEGORY_ERROR_EXTENSION_EMPTY'), JLog::WARNING, 'jerror');
		}


		return $options;
	}

}
