<?php
/**
 * author Ing. Pavel Stary
 * @component CWMulticategories
 * @copyright Copyright (C) Ing. Pavel Stary
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License version 2 or later;
 */
 
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
if(!defined('DS')){
  define('DS',DIRECTORY_SEPARATOR);
} 

jimport( 'joomla.event.plugin' );
jimport('joomla.html.parameter'); 
jimport('joomla.plugin.plugin');
jimport('joomla.registry.registry');

class  plgSystemCWMulticats extends JPlugin{

  /**
   * Load the language file on instantiation.
   * Note this is only available in Joomla 3.1 and higher.
   * If you want to support 3.0 series you must override the constructor
   *
   * @var boolean
   * @since 3.1
   */
    
  protected $autoloadLanguage = true;
    
  function onContentPrepareForm($form, $data){
      //S63 added 1 line to prevent category error on mobile devices:
      if(PlgSystemDeviceSpecificContent::isMobile()) {return;}
      
      //$app = JFactory::getApplication();      
      if ($form->getName()=='com_content.article'){
           //echo "<pre>";print_r($_POST);exit;
          require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_multicats'.DS.'helpers'.DS.'multicats.php' );
          if(!MulticatsHelperAdmin::initFramework()){
            return;
          }          
          
          // for joomla 3.0
          $lang = JFactory::getLanguage();
  		    $lang->load('plg_content_cwmulticats');
                    
          $form->reset( true ); // to reset the form xml loaded by the view

          JForm::addFormPath(JPATH_PLUGINS.DS.'content'.DS.'cwmulticats'.DS.'cwmulticats');
          //$form->loadFile(JPATH_PLUGINS.DS.'content'.DS.'cwmulticats'.DS.'cwmulticats'.DS.'fields.xml', false);
          
          $app = JFactory::getApplication(); 
          if($app->isAdmin()){
            $form->loadFile(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_multicats'.DS.'models'.DS.'forms'.DS.'article.xml', false);
          } else {
            $form->loadFile(JPATH_SITE.DS.'components'.DS.'com_multicats'.DS.'models'.DS.'forms'.DS.'article.xml', false);          
          }
          self::preprocessForm($form, $data);
      }
  }

  /**
   * Taken from model to load it here again after form reset
   */     
	function preprocessForm(JForm $form, $data, $group = 'content')
	{
		
    $app = JFactory::getApplication();
    
    // check if front x backend - means different ID parameter name
    if($app->isAdmin() == true){
      $id = $app->input->get('id');
    } else {
      $id = $app->input->get('a_id');
    }

    $mcats = $this->getMcats($id); 
    if(isset($mcats->catid) && isset($data->catid)){
      $data->catid = $mcats->catid;
    } else {

    }
    
    //echo "<pre>"; print_r($data); exit;
    
    // Association content items
		$app = JFactory::getApplication();
		$assoc = JLanguageAssociations::isEnabled();

		if ($assoc)
		{
			$languages = JLanguageHelper::getLanguages('lang_code');
			$addform = new SimpleXMLElement('<form />');
			$fields = $addform->addChild('fields');
			$fields->addAttribute('name', 'associations');
			$fieldset = $fields->addChild('fieldset');
			$fieldset->addAttribute('name', 'item_associations');
			$fieldset->addAttribute('description', 'COM_CONTENT_ITEM_ASSOCIATIONS_FIELDSET_DESC');
			$add = false;

			foreach ($languages as $tag => $language)
			{
				if (empty($data->language) || $tag != $data->language)
				{
					$add = true;
					$field = $fieldset->addChild('field');
					$field->addAttribute('name', $tag);
					$field->addAttribute('type', 'modal_article');
					$field->addAttribute('language', $tag);
					$field->addAttribute('label', $language->title);
					$field->addAttribute('translate_label', 'false');
					$field->addAttribute('edit', 'true');
					$field->addAttribute('clear', 'true');
				}
			}

			if ($add)
			{
				$form->load($addform, false);
			}
		}
    //comment out that would cause loop as it runs plugins over form - TODO re-think this solution
		//parent::preprocessFormParent($form, $data, $group);
	}
  
  public function onContentAfterSave($context, $article, $isNew){    
    
    if($context == 'com_content.article' || $context == 'com_content.form'){          
        //echo "<pre>"; print_r($_POST);exit;
        // check if exists already a row
        $mcats = $this->getMcats($article->id);
        require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_multicats'.DS.'helpers'.DS.'multicats.php' );
        if(!MulticatsHelperAdmin::initFramework()){
          return;
        }    
        $db = JFactory::getDbo();
        
        if($mcats){
          // Create an object for the record we are going to update.
          $object = new stdClass();
        
          $object->id = $mcats->id;
          $object->item_id = $article->id;
          $object->catid = $article->catid;
           
          $result = $db->updateObject('#__multicats_content_catid', $object, 'id');    
 
          //store into ordering - initialize it
          $catids = explode(',',$article->catid);

          foreach($catids as $catid){
              //check if article has ordering saved already
              $query = "SELECT ordering FROM #__content_multicats WHERE content_id = ".$article->id." AND catid =".$catid;
              $db->setQuery($query);
              $ordering = $db->loadResult();

              if(!$ordering) {
                //get max ordering in category
                $query = "SELECT MAX(ordering) FROM #__content_multicats WHERE catid =".$catid;
                $db->setQuery($query);
                $max = $db->loadResult();
                
                $object = new stdClass();
                $object->content_id = $article->id;
                $object->catid = $catid;
                $object->ordering = $max + 10;
          
                $result = $db->insertObject('#__content_multicats', $object);
              } 
          }

 
        } else {
          // Create and populate an object.
          $object = new stdClass();
          $object->item_id = $article->id;
          $object->catid = $article->catid;
    
          $result = $db->insertObject('#__multicats_content_catid', $object);   
          
          //store into ordering - initialize it
          $catids = explode(',',$article->catid);

          foreach($catids as $catid){
              //get max ordering in category
              $query = "SELECT MAX(ordering) FROM #__content_multicats WHERE catid =".$catid;
              $db->setQuery($query);
              $max = $db->loadResult();

              $object = new stdClass();
              $object->content_id = $article->id;
              $object->catid = $catid;
              $object->ordering = $max + 10;
        
              $result = $db->insertObject('#__content_multicats', $object); 
          }

                      
        }
        // store in article params
        $jsoncatids = json_encode($catids);
        
        $attribs = json_decode($article->attribs);
        $attribs->multicats = $jsoncatids;
          $object = new stdClass();
        
          $object->id = $article->id;
          $object->attribs = json_encode($attribs);
           
          $result = $db->updateObject('#__content', $object, 'id'); 
    }

  }

	public function onContentBeforeDelete($context, $article) {
  }
  
  public function onContentPrepare( $context, $article, &$params, $page = 0 ) {
  }

  public function onContentBeforeDisplay($context, $article, $params, $limitstart=0) {
  }
  
  private function getMcats($id){
    $db = JFactory::getDbo();
    
    if($id > 0){
      $query = $db->getQuery(true);
      $query->select('id,catid')
        ->from('#__multicats_content_catid')
        ->where('item_id = '.(int)$id);
      $db->setQuery($query);
      $mcats = $db->loadObject();
    } else {
      $mcats = new stdClass();
      $mcats->catid = '';
    }
    
    return $mcats;  
  }         
  
  public function onExtensionAfterSave($option, $data) {

      if ( ($option == 'com_config.component') && ( $data->element == 'com_multicats' ) ) {
      
          $params = new JRegistry;
          $params->loadString($data->params);
          
      
          $dlid   = $params->get('downloadid', '');
          $cuser  = $params->get('user', '');
          $cpwd   = $params->get('password', '');
      
          if(!empty($dlid) and !empty($cuser) and !empty($cpwd) )
          {

              $settings = array();
              $settings['u'] = urlencode($cuser);
              $settings['p'] = urlencode($cpwd); 
              $params = json_encode($settings); 
              $extra_query = "'dlid=$dlid&site=".JUri::root()."&conf=".$params."'";
          
              $db = JFactory::getDbo();
              
              $query = $db->getQuery(true)
              ->update('#__update_sites')
              ->set('extra_query = '.$extra_query)
              ->where('name = "CW Multicats Update server"');
              $db->setQuery($query);
              $db->execute();


          }
      }
  }

}
?>